<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

add_event_handler('loc_begin_index', 'protalbum_begin_index',60);
function protalbum_begin_index()
{
  global $template, $page;
  $cat_id = NULL;
  if (isset($page['category']))
  {
    if (is_numeric($page['category']['id']))
      $cat_id = $page['category']['id'];
    else
      trigger_error( 'Bad album id', E_USER_ERROR);

    // If we have authenticated for this category, we are ok
    if (isset($_SESSION['protectalbum_authenticated_'.$cat_id]) && $_SESSION['protectalbum_authenticated_'.$cat_id] === TRUE)
      return;

    // Does this category or any of its parents require a password?
    $query='SELECT uppercats FROM '.CATEGORIES_TABLE.' WHERE id='.$cat_id;
    $result = pwg_query($query);
    $row = mysql_fetch_array($result);
    $uppercats = $row[0];

    // Have we already authenticated to the next previous category?
    $ar_uppercats = array_reverse(explode(",",$uppercats));
    foreach ($ar_uppercats as $_cat_id)
    {
      // Walk our way back up the uppercats looking for a password protected category
      // If we find it, check if we're authed, if not, get auth
      $query='SELECT COUNT(*) FROM '.PROTECTALBUM_TABLE.' WHERE cat_id = '.$_cat_id.' AND enabled=\'true\'';
      $result = pwg_query($query);
      $row = mysql_fetch_array($result);
      if ($row[0] != "0")
      {
        if (isset($_SESSION['protectalbum_authenticated_'.$_cat_id]) 
	      && $_SESSION['protectalbum_authenticated_'.$_cat_id] === TRUE) 
		      return;
        $_SESSION['protectalbum_redir'] = $_SERVER['REQUEST_URI'];
        redirect(get_absolute_root_url()."index.php?/password/".$cat_id);
      }
    }
  }
}

add_event_handler('loc_end_index', 'protalbum_end_index',60);
function protalbum_end_index()
{
  global $template, $page;
  $cat_id = NULL;
  $messages = NULL;
  if (substr(@$_SERVER['QUERY_STRING'],0,10) == "/password/")
  {
    if (is_numeric(substr(@$_SERVER['QUERY_STRING'],10)))
      $cat_id = substr(@$_SERVER['QUERY_STRING'],10);
    else
      trigger_error( 'Bad album id', E_USER_ERROR);

    // Get password info
    // We need to get the passwords for the closest level to this category
    // so get the list and read the last row
    $query='SELECT uppercats FROM '.CATEGORIES_TABLE.' WHERE id='.$cat_id;
    $result = pwg_query($query);
    $row = mysql_fetch_array($result);
    $uppercats = $row[0];
    $query='SELECT cat_id, question, password, (SELECT name FROM '.CATEGORIES_TABLE.' WHERE id=cat_id) AS cat_name FROM '.PROTECTALBUM_TABLE.' WHERE cat_id IN ('.$uppercats.') AND enabled=\'true\'';
    $result = pwg_query($query);
    while ($row = mysql_fetch_array($result))
    {
      $prot_cat_id = $row[0];
      $question = $row[1];
      $password = $row[2];
      $cat_name = $row[3];
    }

    // Did they enter a password?
    if (isset($_POST['protectalbum_password'])) 
    {
      if ($_POST['protectalbum_password'] == $password)
      {
	// OK, set session and do redir
	$_SESSION['protectalbum_authenticated_'.$prot_cat_id] = TRUE;
	if (!isset($_SESSION['protectalbum_redir']))
	  redirect(get_absolute_root_url()."index.php?/category/".$cat_id);
	else
	  redirect($_SESSION['protectalbum_redir']);
      }
      else
      {
	//if (!isset($page['infos']))
	//  $page['infos'] = array();
        //array_push($page['infos'], "Login Incorrect");
	$messages = "<div class=\"errors\">Login Incorrect</div>";
      }
    }

    $loginform = file_get_contents(PROTECTALBUM_PATH.'template/login_form.tpl')."\n";
    $loginform = str_replace("{QUESTION}", $question, $loginform);
    $loginform = str_replace("{CATEGORY_NAME}", $cat_name, $loginform);
    $loginform = str_replace("{MESSAGES}", $messages, $loginform);
    $template->assign(
      array( 
	'CONTENT_DESCRIPTION' => $loginform,
	'CATEGORIES'=>array(),
    	'TITLE'=>'Password Protected Event'));
  }
}

?>
